@cache struct Vern6Cache{
        uType, rateType, uNoUnitsType, TabType, StageLimiter, StepLimiter,
        Thread, L,
    } <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k6::rateType
    k7::rateType
    k8::rateType
    k9::rateType
    utilde::uType
    tmp::uType
    rtmp::rateType
    atmp::uNoUnitsType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    lazy::L
end

get_fsalfirstlast(cache::Vern6Cache, u) = (cache.k1, cache.k9)

function alg_cache(
        alg::Vern6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = Vern6Tableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = k2
    k4 = zero(rate_prototype)
    k5 = zero(rate_prototype)
    k6 = zero(rate_prototype)
    k7 = zero(rate_prototype)
    k8 = k3
    k9 = zero(rate_prototype)
    utilde = zero(u)
    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    rtmp = uEltypeNoUnits === eltype(u) ? utilde : zero(rate_prototype)
    return Vern6Cache(
        u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, utilde, tmp, rtmp, atmp, tab,
        alg.stage_limiter!, alg.step_limiter!, alg.thread, alg.lazy
    )
end

struct Vern6ConstantCache{TabType, L} <: OrdinaryDiffEqConstantCache
    tab::TabType
    lazy::L
end

function alg_cache(
        alg::Vern6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = Vern6Tableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Vern6ConstantCache(tab, alg.lazy)
end

@cache struct Vern7Cache{
        uType, rateType, uNoUnitsType, StageLimiter, StepLimiter,
        Thread, L,
    } <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k6::rateType
    k7::rateType
    k8::rateType
    k9::rateType
    k10::rateType
    utilde::uType
    tmp::uType
    rtmp::rateType
    atmp::uNoUnitsType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    lazy::L
end

# fake values since non-FSAL method
get_fsalfirstlast(cache::Vern7Cache, u) = (nothing, nothing)

function alg_cache(
        alg::Vern7, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = k2
    k4 = zero(rate_prototype)
    k5 = zero(rate_prototype)
    k6 = zero(rate_prototype)
    k7 = zero(rate_prototype)
    k8 = zero(rate_prototype)
    k9 = zero(rate_prototype)
    k10 = k2
    utilde = zero(u)
    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    rtmp = uEltypeNoUnits === eltype(u) ? utilde : zero(rate_prototype)
    return Vern7Cache(
        u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, utilde, tmp, rtmp, atmp,
        alg.stage_limiter!, alg.step_limiter!, alg.thread, alg.lazy
    )
end

struct Vern7ConstantCache{L} <: OrdinaryDiffEqConstantCache
    lazy::L
end

function alg_cache(
        alg::Vern7, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return Vern7ConstantCache(alg.lazy)
end

@cache struct Vern8Cache{
        uType, rateType, uNoUnitsType, TabType, StageLimiter, StepLimiter,
        Thread, L,
    } <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k6::rateType
    k7::rateType
    k8::rateType
    k9::rateType
    k10::rateType
    k11::rateType
    k12::rateType
    k13::rateType
    utilde::uType
    tmp::uType
    rtmp::rateType
    atmp::uNoUnitsType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    lazy::L
end

# fake values since non-FSAL method
get_fsalfirstlast(cache::Vern8Cache, u) = (nothing, nothing)

function alg_cache(
        alg::Vern8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = Vern8Tableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = k2
    k4 = zero(rate_prototype)
    k5 = k2
    k6 = zero(rate_prototype)
    k7 = zero(rate_prototype)
    k8 = zero(rate_prototype)
    tmp = zero(u)
    k9 = zero(rate_prototype)
    k10 = zero(rate_prototype)
    k11 = zero(rate_prototype)
    k12 = zero(rate_prototype)
    k13 = k4
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    rtmp = uEltypeNoUnits === eltype(u) ? utilde : zero(rate_prototype)
    return Vern8Cache(
        u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, utilde,
        tmp, rtmp, atmp, tab, alg.stage_limiter!, alg.step_limiter!, alg.thread, alg.lazy
    )
end

struct Vern8ConstantCache{TabType, L} <: OrdinaryDiffEqConstantCache
    tab::TabType
    lazy::L
end

function alg_cache(
        alg::Vern8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = Vern8Tableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Vern8ConstantCache(tab, alg.lazy)
end

@cache struct Vern9Cache{
        uType, rateType, uNoUnitsType, StageLimiter, StepLimiter,
        Thread, L,
    } <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k6::rateType
    k7::rateType
    k8::rateType
    k9::rateType
    k10::rateType
    k11::rateType
    k12::rateType
    k13::rateType
    k14::rateType
    k15::rateType
    k16::rateType
    utilde::uType
    tmp::uType
    rtmp::rateType
    atmp::uNoUnitsType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    lazy::L
end

# fake values since non-FSAL method
get_fsalfirstlast(cache::Vern9Cache, u) = (nothing, nothing)

function alg_cache(
        alg::Vern9, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = k2
    k4 = zero(rate_prototype)
    k5 = k3
    k6 = zero(rate_prototype)
    k7 = k4
    k8 = k5
    k9 = zero(rate_prototype)
    k10 = zero(rate_prototype)
    k11 = zero(rate_prototype)
    k12 = zero(rate_prototype)
    k13 = zero(rate_prototype)
    k14 = zero(rate_prototype)
    k15 = zero(rate_prototype)
    k16 = k6
    utilde = zero(u)
    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    rtmp = uEltypeNoUnits === eltype(u) ? utilde : zero(rate_prototype)
    return Vern9Cache(
        u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, k14, k15,
        k16, utilde, tmp, rtmp, atmp, alg.stage_limiter!, alg.step_limiter!,
        alg.thread, alg.lazy
    )
end

struct Vern9ConstantCache{L} <: OrdinaryDiffEqConstantCache
    lazy::L
end

function alg_cache(
        alg::Vern9, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return Vern9ConstantCache(alg.lazy)
end

@cache struct RKV76IIaCache{
        uType, rateType, uNoUnitsType, TabType, StageLimiter, StepLimiter,
        Thread, L,
    } <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k6::rateType
    k7::rateType
    k8::rateType
    k9::rateType
    k10::rateType
    utilde::uType
    tmp::uType
    rtmp::rateType
    atmp::uNoUnitsType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    lazy::L
end

# fake values since non-FSAL method
get_fsalfirstlast(cache::RKV76IIaCache, u) = (nothing, nothing)

function alg_cache(
        alg::RKV76IIa, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = RKV76IIaTableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = k2
    k4 = zero(rate_prototype)
    k5 = zero(rate_prototype)
    k6 = zero(rate_prototype)
    k7 = zero(rate_prototype)
    k8 = k3
    k9 = zero(rate_prototype)
    k10 = k4
    utilde = zero(u)
    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    rtmp = uEltypeNoUnits === eltype(u) ? utilde : zero(rate_prototype)
    return RKV76IIaCache(
        u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, utilde, tmp, rtmp, atmp, tab,
        alg.stage_limiter!, alg.step_limiter!, alg.thread, alg.lazy
    )
end

struct RKV76IIaConstantCache{TabType, L} <: OrdinaryDiffEqConstantCache
    tab::TabType
    lazy::L
end

function alg_cache(
        alg::RKV76IIa, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = RKV76IIaTableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return RKV76IIaConstantCache(tab, alg.lazy)
end

function initialize!(integrator, cache::Vern6ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 9) : (integrator.kshortsize = 12)
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    @inbounds for i in 2:8
        integrator.k[i] = zero(integrator.fsalfirst)
    end
    integrator.k[integrator.kshortsize] = integrator.fsallast

    return if !_unwrap_val(cache.lazy)
        @inbounds for i in 10:12
            integrator.k[i] = zero(integrator.fsalfirst)
        end
    end
end

@muladd function perform_step!(integrator, cache::Vern6ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; c1, c2, c3, c4, c5, c6, a21, a31, a32, a41, a43, a51, a53, a54, a61, a63, a64, a65, a71, a73, a74, a75, a76, a81, a83, a84, a85, a86, a87, a91, a94, a95, a96, a97, a98, btilde1, btilde4, btilde5, btilde6, btilde7, btilde8, btilde9) = cache.tab
    k1 = integrator.fsalfirst
    a = dt * a21
    k2 = f(uprev + a * k1, p, t + c1 * dt)
    k3 = f(uprev + dt * (a31 * k1 + a32 * k2), p, t + c2 * dt)
    k4 = f(uprev + dt * (a41 * k1 + a43 * k3), p, t + c3 * dt)
    k5 = f(uprev + dt * (a51 * k1 + a53 * k3 + a54 * k4), p, t + c4 * dt)
    k6 = f(uprev + dt * (a61 * k1 + a63 * k3 + a64 * k4 + a65 * k5), p, t + c5 * dt)
    k7 = f(
        uprev + dt * (a71 * k1 + a73 * k3 + a74 * k4 + a75 * k5 + a76 * k6), p,
        t + c6 * dt
    )
    g8 = uprev + dt * (a81 * k1 + a83 * k3 + a84 * k4 + a85 * k5 + a86 * k6 + a87 * k7)
    k8 = f(g8, p, t + dt)
    u = uprev + dt * (a91 * k1 + a94 * k4 + a95 * k5 + a96 * k6 + a97 * k7 + a98 * k8)
    integrator.fsallast = f(u, p, t + dt)
    k9 = integrator.fsallast
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
    if integrator.alg isa CompositeAlgorithm
        g9 = u
        integrator.eigen_est = integrator.opts.internalnorm(
            maximum(abs.((k9 .- k8) ./ (g9 .- g8))), t
        )
    end
    if integrator.opts.adaptive
        utilde = dt *
            (
            btilde1 * k1 + btilde4 * k4 + btilde5 * k5 + btilde6 * k6 + btilde7 * k7 +
                btilde8 * k8 + btilde9 * k9
        )
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    integrator.k[1] = k1
    integrator.k[2] = k2
    integrator.k[3] = k3
    integrator.k[4] = k4
    integrator.k[5] = k5
    integrator.k[6] = k6
    integrator.k[7] = k7
    integrator.k[8] = k8
    integrator.k[9] = k9

    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        (; c10, a1001, a1004, a1005, a1006, a1007, a1008, a1009, c11, a1101, a1104, a1105, a1106, a1107, a1108, a1109, a1110, c12, a1201, a1204, a1205, a1206, a1207, a1208, a1209, a1210, a1211) = cache.tab.extra
        k[10] = f(
            uprev +
                dt * (
                a1001 * k[1] + a1004 * k[4] + a1005 * k[5] + a1006 * k[6] +
                    a1007 * k[7] + a1008 * k[8] + a1009 * k[9]
            ),
            p,
            t + c10 * dt
        )
        k[11] = f(
            uprev +
                dt * (
                a1101 * k[1] + a1104 * k[4] + a1105 * k[5] + a1106 * k[6] +
                    a1107 * k[7] + a1108 * k[8] + a1109 * k[9] + a1110 * k[10]
            ),
            p,
            t + c11 * dt
        )
        k[12] = f(
            uprev +
                dt * (
                a1201 * k[1] + a1204 * k[4] + a1205 * k[5] + a1206 * k[6] +
                    a1207 * k[7] + a1208 * k[8] + a1209 * k[9] + a1210 * k[10] +
                    a1211 * k[11]
            ),
            p,
            t + c12 * dt
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    end

    integrator.u = u
end

function initialize!(integrator, cache::Vern6Cache)
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 9) : (integrator.kshortsize = 12)
    (; k) = integrator
    resize!(k, integrator.kshortsize)
    k[1] = cache.k1
    k[2] = cache.k2
    k[3] = cache.k3
    k[4] = cache.k4
    k[5] = cache.k5
    k[6] = cache.k6
    k[7] = cache.k7
    k[8] = cache.k8
    k[9] = cache.k9 # Set the pointers

    if !_unwrap_val(cache.lazy)
        k[10] = similar(cache.k1)
        k[11] = similar(cache.k1)
        k[12] = similar(cache.k1)
    end

    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::Vern6Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    uidx = eachindex(integrator.uprev)
    (; c1, c2, c3, c4, c5, c6, a21, a31, a32, a41, a43, a51, a53, a54, a61, a63, a64, a65, a71, a73, a74, a75, a76, a81, a83, a84, a85, a86, a87, a91, a94, a95, a96, a97, a98, btilde1, btilde4, btilde5, btilde6, btilde7, btilde8, btilde9) = cache.tab
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, utilde, tmp, rtmp, atmp, stage_limiter!, step_limiter!, thread) = cache
    a = dt * a21
    @.. broadcast = false thread = thread tmp = uprev + a * k1
    stage_limiter!(tmp, integrator, p, t + c1 * dt)
    f(k2, tmp, p, t + c1 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a31 * k1 + a32 * k2)
    stage_limiter!(tmp, integrator, p, t + c2 * dt)
    f(k3, tmp, p, t + c2 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a41 * k1 + a43 * k3)
    stage_limiter!(tmp, integrator, p, t + c3 * dt)
    f(k4, tmp, p, t + c3 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a51 * k1 + a53 * k3 + a54 * k4)
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k5, tmp, p, t + c4 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (a61 * k1 + a63 * k3 + a64 * k4 + a65 * k5)
    stage_limiter!(tmp, integrator, p, t + c5 * dt)
    f(k6, tmp, p, t + c5 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a71 * k1 + a73 * k3 + a74 * k4 + a75 * k5 +
            a76 * k6
    )
    stage_limiter!(tmp, integrator, p, t + c6 * dt)
    f(k7, tmp, p, t + c6 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a81 * k1 + a83 * k3 + a84 * k4 + a85 * k5 +
            a86 * k6 +
            a87 * k7
    )
    stage_limiter!(tmp, integrator, p, t + dt)
    f(k8, tmp, p, t + dt)
    @.. broadcast = false thread = thread u = uprev +
        dt *
        (
        a91 * k1 + a94 * k4 + a95 * k5 + a96 * k6 +
            a97 * k7 + a98 * k8
    )
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    f(k9, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
    if integrator.alg isa CompositeAlgorithm
        g9 = u
        g8 = tmp
        @.. broadcast = false thread = thread rtmp = abs((k9 - k8) / (g9 - g8))
        integrator.eigen_est = integrator.opts.internalnorm(norm(rtmp, Inf), t)
    end
    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = dt * (
            btilde1 * k1 + btilde4 * k4 +
                btilde5 * k5 +
                btilde6 * k6 + btilde7 * k7 +
                btilde8 * k8 +
                btilde9 * k9
        )
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        (; c10, a1001, a1004, a1005, a1006, a1007, a1008, a1009, c11, a1101, a1104, a1105, a1106, a1107, a1108, a1109, a1110, c12, a1201, a1204, a1205, a1206, a1207, a1208, a1209, a1210, a1211) = cache.tab.extra
        (; tmp) = cache
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1001 * k[1] + a1004 * k[4] + a1005 * k[5] +
                a1006 * k[6] +
                a1007 * k[7] + a1008 * k[8] + a1009 * k[9]
        )
        f(k[10], tmp, p, t + c10 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1101 * k[1] + a1104 * k[4] + a1105 * k[5] +
                a1106 * k[6] +
                a1107 * k[7] + a1108 * k[8] + a1109 * k[9] +
                a1110 * k[10]
        )
        f(k[11], tmp, p, t + c11 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1201 * k[1] + a1204 * k[4] + a1205 * k[5] +
                a1206 * k[6] +
                a1207 * k[7] + a1208 * k[8] + a1209 * k[9] +
                a1210 * k[10] + a1211 * k[11]
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        f(k[12], tmp, p, t + c12 * dt)
    end
    return nothing
end

function initialize!(integrator, cache::Vern7ConstantCache)
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 10) : (integrator.kshortsize = 16)
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    return @inbounds for i in eachindex(integrator.k)
        integrator.k[i] = zero(integrator.uprev) ./ oneunit(integrator.t)
    end
end

@muladd function perform_step!(integrator, cache::Vern7ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, k, f, p) = integrator
    T = constvalue(recursive_unitless_bottom_eltype(u))
    T2 = constvalue(typeof(one(t)))
    @OnDemandTableauExtract Vern7Tableau T T2
    k1 = f(uprev, p, t)
    a = dt * a021
    k2 = f(uprev + a * k1, p, t + c2 * dt)
    k3 = f(uprev + dt * (a031 * k1 + a032 * k2), p, t + c3 * dt)
    k4 = f(uprev + dt * (a041 * k1 + a043 * k3), p, t + c4 * dt)
    k5 = f(uprev + dt * (a051 * k1 + a053 * k3 + a054 * k4), p, t + c5 * dt)
    k6 = f(uprev + dt * (a061 * k1 + a063 * k3 + a064 * k4 + a065 * k5), p, t + c6 * dt)
    k7 = f(
        uprev + dt * (a071 * k1 + a073 * k3 + a074 * k4 + a075 * k5 + a076 * k6), p,
        t + c7 * dt
    )
    k8 = f(
        uprev +
            dt * (a081 * k1 + a083 * k3 + a084 * k4 + a085 * k5 + a086 * k6 + a087 * k7),
        p,
        t + c8 * dt
    )
    g9 = uprev +
        dt *
        (a091 * k1 + a093 * k3 + a094 * k4 + a095 * k5 + a096 * k6 + a097 * k7 + a098 * k8)
    g10 = uprev +
        dt * (a101 * k1 + a103 * k3 + a104 * k4 + a105 * k5 + a106 * k6 + a107 * k7)
    k9 = f(g9, p, t + dt)
    k10 = f(g10, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
    u = uprev + dt * (b1 * k1 + b4 * k4 + b5 * k5 + b6 * k6 + b7 * k7 + b8 * k8 + b9 * k9)
    if integrator.alg isa CompositeAlgorithm
        integrator.eigen_est = integrator.opts.internalnorm(
            maximum(abs.((k10 .- k9) ./ (g10 .- g9))), t
        )
    end
    if integrator.opts.adaptive
        utilde = dt *
            (
            btilde1 * k1 + btilde4 * k4 + btilde5 * k5 + btilde6 * k6 + btilde7 * k7 +
                btilde8 * k8 + btilde9 * k9 + btilde10 * k10
        )
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    integrator.k[1] = k1
    integrator.k[2] = k2
    integrator.k[3] = k3
    integrator.k[4] = k4
    integrator.k[5] = k5
    integrator.k[6] = k6
    integrator.k[7] = k7
    integrator.k[8] = k8
    integrator.k[9] = k9
    integrator.k[10] = k10
    integrator.u = u

    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        @OnDemandTableauExtract Vern7ExtraStages T T2
        k[11] = f(
            uprev +
                dt * (
                a1101 * k[1] + a1104 * k[4] + a1105 * k[5] + a1106 * k[6] +
                    a1107 * k[7] + a1108 * k[8] + a1109 * k[9]
            ),
            p,
            t + c11 * dt
        )
        k[12] = f(
            uprev +
                dt * (
                a1201 * k[1] + a1204 * k[4] + a1205 * k[5] + a1206 * k[6] +
                    a1207 * k[7] + a1208 * k[8] + a1209 * k[9] + a1211 * k[11]
            ),
            p,
            t + c12 * dt
        )
        k[13] = f(
            uprev +
                dt * (
                a1301 * k[1] + a1304 * k[4] + a1305 * k[5] + a1306 * k[6] +
                    a1307 * k[7] + a1308 * k[8] + a1309 * k[9] + a1311 * k[11] +
                    a1312 * k[12]
            ),
            p,
            t + c13 * dt
        )
        k[14] = f(
            uprev +
                dt * (
                a1401 * k[1] + a1404 * k[4] + a1405 * k[5] + a1406 * k[6] +
                    a1407 * k[7] + a1408 * k[8] + a1409 * k[9] + a1411 * k[11] +
                    a1412 * k[12] + a1413 * k[13]
            ),
            p,
            t + c14 * dt
        )
        k[15] = f(
            uprev +
                dt * (
                a1501 * k[1] + a1504 * k[4] + a1505 * k[5] + a1506 * k[6] +
                    a1507 * k[7] + a1508 * k[8] + a1509 * k[9] + a1511 * k[11] +
                    a1512 * k[12] + a1513 * k[13]
            ),
            p,
            t + c15 * dt
        )
        k[16] = f(
            uprev +
                dt * (
                a1601 * k[1] + a1604 * k[4] + a1605 * k[5] + a1606 * k[6] +
                    a1607 * k[7] + a1608 * k[8] + a1609 * k[9] + a1611 * k[11] +
                    a1612 * k[12] + a1613 * k[13]
            ),
            p,
            t + c16 * dt
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    end
end

function initialize!(integrator, cache::Vern7Cache)
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, k10) = cache
    (; k) = integrator
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 10) : (integrator.kshortsize = 16)
    resize!(k, integrator.kshortsize)
    k[1] = k1
    k[2] = k2
    k[3] = k3
    k[4] = k4
    k[5] = k5
    k[6] = k6
    k[7] = k7
    k[8] = k8
    k[9] = k9
    k[10] = k10 # Setup pointers

    return if !_unwrap_val(cache.lazy)
        k[11] = similar(cache.k1)
        k[12] = similar(cache.k1)
        k[13] = similar(cache.k1)
        k[14] = similar(cache.k1)
        k[15] = similar(cache.k1)
        k[16] = similar(cache.k1)
    end
end

@muladd function perform_step!(integrator, cache::Vern7Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    T = constvalue(recursive_unitless_bottom_eltype(u))
    T2 = constvalue(typeof(one(t)))
    @OnDemandTableauExtract Vern7Tableau T T2
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, utilde, tmp, rtmp, atmp, stage_limiter!, step_limiter!, thread) = cache
    f(k1, uprev, p, t)
    a = dt * a021
    @.. broadcast = false thread = thread tmp = uprev + a * k1
    stage_limiter!(tmp, integrator, p, t + c2 * dt)
    f(k2, tmp, p, t + c2 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a031 * k1 + a032 * k2)
    stage_limiter!(tmp, integrator, p, t + c3 * dt)
    f(k3, tmp, p, t + c3 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a041 * k1 + a043 * k3)
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k4, tmp, p, t + c4 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a051 * k1 + a053 * k3 + a054 * k4)
    stage_limiter!(tmp, integrator, p, t + c5 * dt)
    f(k5, tmp, p, t + c5 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt *
        (a061 * k1 + a063 * k3 + a064 * k4 + a065 * k5)
    stage_limiter!(tmp, integrator, p, t + c6 * dt)
    f(k6, tmp, p, t + c6 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt *
        (
        a071 * k1 + a073 * k3 + a074 * k4 + a075 * k5 +
            a076 * k6
    )
    stage_limiter!(tmp, integrator, p, t + c7 * dt)
    f(k7, tmp, p, t + c7 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt *
        (
        a081 * k1 + a083 * k3 + a084 * k4 + a085 * k5 +
            a086 * k6 +
            a087 * k7
    )
    stage_limiter!(tmp, integrator, p, t + c8 * dt)
    f(k8, tmp, p, t + c8 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt *
        (
        a091 * k1 + a093 * k3 + a094 * k4 + a095 * k5 +
            a096 * k6 +
            a097 * k7 + a098 * k8
    )
    stage_limiter!(tmp, integrator, p, t + dt)
    f(k9, tmp, p, t + dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt *
        (
        a101 * k1 + a103 * k3 + a104 * k4 + a105 * k5 +
            a106 * k6 +
            a107 * k7
    )
    stage_limiter!(tmp, integrator, p, t + dt)
    f(k10, tmp, p, t + dt)
    @.. broadcast = false thread = thread u = uprev +
        dt *
        (
        b1 * k1 + b4 * k4 + b5 * k5 + b6 * k6 + b7 * k7 +
            b8 * k8 +
            b9 * k9
    )
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
    if integrator.alg isa CompositeAlgorithm
        g10 = u
        g9 = tmp
        @.. broadcast = false thread = thread rtmp = abs((k10 - k9) / (g10 - g9))
        integrator.eigen_est = integrator.opts.internalnorm(norm(rtmp, Inf), t)
    end
    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = dt * (
            btilde1 * k1 + btilde4 * k4 +
                btilde5 * k5 +
                btilde6 * k6 + btilde7 * k7 +
                btilde8 * k8 +
                btilde9 * k9 + btilde10 * k10
        )
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        (; tmp) = cache
        @OnDemandTableauExtract Vern7ExtraStages T T2
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1101 * k[1] + a1104 * k[4] + a1105 * k[5] +
                a1106 * k[6] +
                a1107 * k[7] + a1108 * k[8] + a1109 * k[9]
        )
        f(k[11], tmp, p, t + c11 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1201 * k[1] + a1204 * k[4] + a1205 * k[5] +
                a1206 * k[6] +
                a1207 * k[7] + a1208 * k[8] + a1209 * k[9] +
                a1211 * k[11]
        )
        f(k[12], tmp, p, t + c12 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1301 * k[1] + a1304 * k[4] + a1305 * k[5] +
                a1306 * k[6] +
                a1307 * k[7] + a1308 * k[8] + a1309 * k[9] +
                a1311 * k[11] + a1312 * k[12]
        )
        f(k[13], tmp, p, t + c13 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1401 * k[1] + a1404 * k[4] + a1405 * k[5] +
                a1406 * k[6] +
                a1407 * k[7] + a1408 * k[8] + a1409 * k[9] +
                a1411 * k[11] + a1412 * k[12] +
                a1413 * k[13]
        )
        f(k[14], tmp, p, t + c14 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1501 * k[1] + a1504 * k[4] + a1505 * k[5] +
                a1506 * k[6] +
                a1507 * k[7] + a1508 * k[8] + a1509 * k[9] +
                a1511 * k[11] + a1512 * k[12] +
                a1513 * k[13]
        )
        f(k[15], tmp, p, t + c15 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1601 * k[1] + a1604 * k[4] + a1605 * k[5] +
                a1606 * k[6] +
                a1607 * k[7] + a1608 * k[8] + a1609 * k[9] +
                a1611 * k[11] + a1612 * k[12] +
                a1613 * k[13]
        )
        f(k[16], tmp, p, t + c16 * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    end
    return nothing
end

function initialize!(integrator, cache::Vern8ConstantCache)
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 13) : (integrator.kshortsize = 21)
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    return @inbounds for i in eachindex(integrator.k)
        integrator.k[i] = zero(integrator.uprev) ./ oneunit(integrator.t)
    end
end

@muladd function perform_step!(integrator, cache::Vern8ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, a0201, a0301, a0302, a0401, a0403, a0501, a0503, a0504, a0601, a0604, a0605, a0701, a0704, a0705, a0706, a0801, a0804, a0805, a0806, a0807, a0901, a0904, a0905, a0906, a0907, a0908, a1001, a1004, a1005, a1006, a1007, a1008, a1009, a1101, a1104, a1105, a1106, a1107, a1108, a1109, a1110, a1201, a1204, a1205, a1206, a1207, a1208, a1209, a1210, a1211, a1301, a1304, a1305, a1306, a1307, a1308, a1309, a1310, b1, b6, b7, b8, b9, b10, b11, b12, btilde1, btilde6, btilde7, btilde8, btilde9, btilde10, btilde11, btilde12, btilde13) = cache.tab
    k1 = f(uprev, p, t)
    a = dt * a0201
    k2 = f(uprev + a * k1, p, t + c2 * dt)
    k3 = f(uprev + dt * (a0301 * k1 + a0302 * k2), p, t + c3 * dt)
    k4 = f(uprev + dt * (a0401 * k1 + a0403 * k3), p, t + c4 * dt)
    k5 = f(uprev + dt * (a0501 * k1 + a0503 * k3 + a0504 * k4), p, t + c5 * dt)
    k6 = f(uprev + dt * (a0601 * k1 + a0604 * k4 + a0605 * k5), p, t + c6 * dt)
    k7 = f(uprev + dt * (a0701 * k1 + a0704 * k4 + a0705 * k5 + a0706 * k6), p, t + c7 * dt)
    k8 = f(
        uprev + dt * (a0801 * k1 + a0804 * k4 + a0805 * k5 + a0806 * k6 + a0807 * k7), p,
        t + c8 * dt
    )
    k9 = f(
        uprev +
            dt *
            (a0901 * k1 + a0904 * k4 + a0905 * k5 + a0906 * k6 + a0907 * k7 + a0908 * k8),
        p,
        t + c9 * dt
    )
    k10 = f(
        uprev +
            dt *
            (
            a1001 * k1 + a1004 * k4 + a1005 * k5 + a1006 * k6 + a1007 * k7 + a1008 * k8 +
                a1009 * k9
        ),
        p,
        t + c10 * dt
    )
    k11 = f(
        uprev +
            dt *
            (
            a1101 * k1 + a1104 * k4 + a1105 * k5 + a1106 * k6 + a1107 * k7 + a1108 * k8 +
                a1109 * k9 + a1110 * k10
        ),
        p,
        t + c11 * dt
    )
    g12 = uprev +
        dt *
        (
        a1201 * k1 + a1204 * k4 + a1205 * k5 + a1206 * k6 + a1207 * k7 + a1208 * k8 +
            a1209 * k9 + a1210 * k10 + a1211 * k11
    )
    g13 = uprev +
        dt *
        (
        a1301 * k1 + a1304 * k4 + a1305 * k5 + a1306 * k6 + a1307 * k7 + a1308 * k8 +
            a1309 * k9 + a1310 * k10
    )
    k12 = f(g12, p, t + dt)
    k13 = f(g13, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 13)
    u = uprev +
        dt * (
        b1 * k1 + b6 * k6 + b7 * k7 + b8 * k8 + b9 * k9 + b10 * k10 + b11 * k11 +
            b12 * k12
    )
    if integrator.alg isa CompositeAlgorithm
        integrator.eigen_est = integrator.opts.internalnorm(
            maximum(abs.((k13 .- k12) ./ (g13 .- g12))), t
        )
    end
    if integrator.opts.adaptive
        utilde = dt *
            (
            btilde1 * k1 + btilde6 * k6 + btilde7 * k7 + btilde8 * k8 + btilde9 * k9 +
                btilde10 * k10 + btilde11 * k11 + btilde12 * k12 + btilde13 * k13
        )
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    integrator.k[1] = k1
    integrator.k[2] = k2
    integrator.k[3] = k3
    integrator.k[4] = k4
    integrator.k[5] = k5
    integrator.k[6] = k6
    integrator.k[7] = k7
    integrator.k[8] = k8
    integrator.k[9] = k9
    integrator.k[10] = k10
    integrator.k[11] = k11
    integrator.k[12] = k12
    integrator.k[13] = k13
    integrator.u = u

    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        (; c14, a1401, a1406, a1407, a1408, a1409, a1410, a1411, a1412, c15, a1501, a1506, a1507, a1508, a1509, a1510, a1511, a1512, a1514, c16, a1601, a1606, a1607, a1608, a1609, a1610, a1611, a1612, a1614, a1615, c17, a1701, a1706, a1707, a1708, a1709, a1710, a1711, a1712, a1714, a1715, a1716, c18, a1801, a1806, a1807, a1808, a1809, a1810, a1811, a1812, a1814, a1815, a1816, a1817, c19, a1901, a1906, a1907, a1908, a1909, a1910, a1911, a1912, a1914, a1915, a1916, a1917, c20, a2001, a2006, a2007, a2008, a2009, a2010, a2011, a2012, a2014, a2015, a2016, a2017, c21, a2101, a2106, a2107, a2108, a2109, a2110, a2111, a2112, a2114, a2115, a2116, a2117) = cache.tab.extra
        k[14] = f(
            uprev +
                dt * (
                a1401 * k[1] + a1406 * k[6] + a1407 * k[7] + a1408 * k[8] +
                    a1409 * k[9] + a1410 * k[10] + a1411 * k[11] + a1412 * k[12]
            ),
            p,
            t + c14 * dt
        )
        k[15] = f(
            uprev +
                dt * (
                a1501 * k[1] + a1506 * k[6] + a1507 * k[7] + a1508 * k[8] +
                    a1509 * k[9] + a1510 * k[10] + a1511 * k[11] + a1512 * k[12] +
                    a1514 * k[14]
            ),
            p,
            t + c15 * dt
        )
        k[16] = f(
            uprev +
                dt * (
                a1601 * k[1] + a1606 * k[6] + a1607 * k[7] + a1608 * k[8] +
                    a1609 * k[9] + a1610 * k[10] + a1611 * k[11] + a1612 * k[12] +
                    a1614 * k[14] + a1615 * k[15]
            ),
            p,
            t + c16 * dt
        )
        k[17] = f(
            uprev +
                dt * (
                a1701 * k[1] + a1706 * k[6] + a1707 * k[7] + a1708 * k[8] +
                    a1709 * k[9] + a1710 * k[10] + a1711 * k[11] + a1712 * k[12] +
                    a1714 * k[14] + a1715 * k[15] + a1716 * k[16]
            ),
            p,
            t + c17 * dt
        )
        k[18] = f(
            uprev +
                dt * (
                a1801 * k[1] + a1806 * k[6] + a1807 * k[7] + a1808 * k[8] +
                    a1809 * k[9] + a1810 * k[10] + a1811 * k[11] + a1812 * k[12] +
                    a1814 * k[14] + a1815 * k[15] + a1816 * k[16] + a1817 * k[17]
            ),
            p,
            t + c18 * dt
        )
        k[19] = f(
            uprev +
                dt * (
                a1901 * k[1] + a1906 * k[6] + a1907 * k[7] + a1908 * k[8] +
                    a1909 * k[9] + a1910 * k[10] + a1911 * k[11] + a1912 * k[12] +
                    a1914 * k[14] + a1915 * k[15] + a1916 * k[16] + a1917 * k[17]
            ),
            p,
            t + c19 * dt
        )
        k[20] = f(
            uprev +
                dt * (
                a2001 * k[1] + a2006 * k[6] + a2007 * k[7] + a2008 * k[8] +
                    a2009 * k[9] + a2010 * k[10] + a2011 * k[11] + a2012 * k[12] +
                    a2014 * k[14] + a2015 * k[15] + a2016 * k[16] + a2017 * k[17]
            ),
            p,
            t + c20 * dt
        )
        k[21] = f(
            uprev +
                dt * (
                a2101 * k[1] + a2106 * k[6] + a2107 * k[7] + a2108 * k[8] +
                    a2109 * k[9] + a2110 * k[10] + a2111 * k[11] + a2112 * k[12] +
                    a2114 * k[14] + a2115 * k[15] + a2116 * k[16] + a2117 * k[17]
            ),
            p,
            t + c21 * dt
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
    end
end

function initialize!(integrator, cache::Vern8Cache)
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13) = cache
    (; k) = integrator
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 13) : (integrator.kshortsize = 21)
    resize!(k, integrator.kshortsize)
    k[1] = k1
    k[2] = k2
    k[3] = k3
    k[4] = k4
    k[5] = k5
    k[6] = k6
    k[7] = k7
    k[8] = k8
    k[9] = k9
    k[10] = k10
    k[11] = k11
    k[12] = k12
    k[13] = k13 # Setup pointers

    return if !_unwrap_val(cache.lazy)
        for i in 14:21
            k[i] = similar(cache.k1)
        end
    end
end

@muladd function perform_step!(integrator, cache::Vern8Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    uidx = eachindex(integrator.uprev)
    (; c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, a0201, a0301, a0302, a0401, a0403, a0501, a0503, a0504, a0601, a0604, a0605, a0701, a0704, a0705, a0706, a0801, a0804, a0805, a0806, a0807, a0901, a0904, a0905, a0906, a0907, a0908, a1001, a1004, a1005, a1006, a1007, a1008, a1009, a1101, a1104, a1105, a1106, a1107, a1108, a1109, a1110, a1201, a1204, a1205, a1206, a1207, a1208, a1209, a1210, a1211, a1301, a1304, a1305, a1306, a1307, a1308, a1309, a1310, b1, b6, b7, b8, b9, b10, b11, b12, btilde1, btilde6, btilde7, btilde8, btilde9, btilde10, btilde11, btilde12, btilde13) = cache.tab
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, utilde, tmp, rtmp, atmp, stage_limiter!, step_limiter!, thread) = cache
    f(k1, uprev, p, t)
    a = dt * a0201
    @.. broadcast = false thread = thread tmp = uprev + a * k1
    stage_limiter!(tmp, integrator, p, t + c2 * dt)
    f(k2, tmp, p, t + c2 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a0301 * k1 + a0302 * k2)
    stage_limiter!(tmp, integrator, p, t + c3 * dt)
    f(k3, tmp, p, t + c3 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a0401 * k1 + a0403 * k3)
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k4, tmp, p, t + c4 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (a0501 * k1 + a0503 * k3 + a0504 * k4)
    stage_limiter!(tmp, integrator, p, t + c5 * dt)
    f(k5, tmp, p, t + c5 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (a0601 * k1 + a0604 * k4 + a0605 * k5)
    stage_limiter!(tmp, integrator, p, t + c6 * dt)
    f(k6, tmp, p, t + c6 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a0701 * k1 + a0704 * k4 + a0705 * k5 +
            a0706 * k6
    )
    stage_limiter!(tmp, integrator, p, t + c7 * dt)
    f(k7, tmp, p, t + c7 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt *
        (
        a0801 * k1 + a0804 * k4 + a0805 * k5 +
            a0806 * k6 + a0807 * k7
    )
    stage_limiter!(tmp, integrator, p, t + c8 * dt)
    f(k8, tmp, p, t + c8 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a0901 * k1 + a0904 * k4 + a0905 * k5 +
            a0906 * k6 +
            a0907 * k7 + a0908 * k8
    )
    stage_limiter!(tmp, integrator, p, t + c9 * dt)
    f(k9, tmp, p, t + c9 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1001 * k1 + a1004 * k4 + a1005 * k5 +
            a1006 * k6 +
            a1007 * k7 + a1008 * k8 + a1009 * k9
    )
    stage_limiter!(tmp, integrator, p, t + c10 * dt)
    f(k10, tmp, p, t + c10 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1101 * k1 + a1104 * k4 + a1105 * k5 +
            a1106 * k6 +
            a1107 * k7 + a1108 * k8 + a1109 * k9 +
            a1110 * k10
    )
    stage_limiter!(tmp, integrator, p, t + c11 * dt)
    f(k11, tmp, p, t + c11 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1201 * k1 + a1204 * k4 + a1205 * k5 +
            a1206 * k6 +
            a1207 * k7 + a1208 * k8 + a1209 * k9 +
            a1210 * k10 +
            a1211 * k11
    )
    stage_limiter!(tmp, integrator, p, t + dt)
    f(k12, tmp, p, t + dt)
    @.. broadcast = false thread = thread u = uprev +
        dt *
        (
        a1301 * k1 + a1304 * k4 + a1305 * k5 + a1306 * k6 +
            a1307 * k7 +
            a1308 * k8 + a1309 * k9 + a1310 * k10
    )
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    f(k13, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 13)
    if integrator.alg isa CompositeAlgorithm
        g13 = u
        g12 = tmp
        @.. broadcast = false thread = thread rtmp = abs((k13 - k12) / (g13 - g12))
        integrator.eigen_est = integrator.opts.internalnorm(norm(rtmp, Inf), t)
    end
    @.. broadcast = false thread = thread u = uprev +
        dt *
        (
        b1 * k1 + b6 * k6 + b7 * k7 + b8 * k8 + b9 * k9 +
            b10 * k10 +
            b11 * k11 + b12 * k12
    )
    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = dt * (
            btilde1 * k1 + btilde6 * k6 +
                btilde7 * k7 +
                btilde8 * k8 + btilde9 * k9 +
                btilde10 * k10 +
                btilde11 * k11 + btilde12 * k12 +
                btilde13 * k13
        )
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        (; c14, a1401, a1406, a1407, a1408, a1409, a1410, a1411, a1412, c15, a1501, a1506, a1507, a1508, a1509, a1510, a1511, a1512, a1514, c16, a1601, a1606, a1607, a1608, a1609, a1610, a1611, a1612, a1614, a1615, c17, a1701, a1706, a1707, a1708, a1709, a1710, a1711, a1712, a1714, a1715, a1716, c18, a1801, a1806, a1807, a1808, a1809, a1810, a1811, a1812, a1814, a1815, a1816, a1817, c19, a1901, a1906, a1907, a1908, a1909, a1910, a1911, a1912, a1914, a1915, a1916, a1917, c20, a2001, a2006, a2007, a2008, a2009, a2010, a2011, a2012, a2014, a2015, a2016, a2017, c21, a2101, a2106, a2107, a2108, a2109, a2110, a2111, a2112, a2114, a2115, a2116, a2117) = cache.tab.extra
        (; tmp) = cache
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1401 * k[1] + a1406 * k[6] + a1407 * k[7] +
                a1408 * k[8] +
                a1409 * k[9] + a1410 * k[10] +
                a1411 * k[11] +
                a1412 * k[12]
        )
        f(k[14], tmp, p, t + c14 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1501 * k[1] + a1506 * k[6] + a1507 * k[7] +
                a1508 * k[8] +
                a1509 * k[9] + a1510 * k[10] +
                a1511 * k[11] +
                a1512 * k[12] + a1514 * k[14]
        )
        f(k[15], tmp, p, t + c15 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1601 * k[1] + a1606 * k[6] + a1607 * k[7] +
                a1608 * k[8] +
                a1609 * k[9] + a1610 * k[10] +
                a1611 * k[11] +
                a1612 * k[12] + a1614 * k[14] +
                a1615 * k[15]
        )
        f(k[16], tmp, p, t + c16 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1701 * k[1] + a1706 * k[6] + a1707 * k[7] +
                a1708 * k[8] +
                a1709 * k[9] + a1710 * k[10] +
                a1711 * k[11] +
                a1712 * k[12] + a1714 * k[14] +
                a1715 * k[15] +
                a1716 * k[16]
        )
        f(k[17], tmp, p, t + c17 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1801 * k[1] + a1806 * k[6] + a1807 * k[7] +
                a1808 * k[8] +
                a1809 * k[9] + a1810 * k[10] +
                a1811 * k[11] +
                a1812 * k[12] + a1814 * k[14] +
                a1815 * k[15] +
                a1816 * k[16] + a1817 * k[17]
        )
        f(k[18], tmp, p, t + c18 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1901 * k[1] + a1906 * k[6] + a1907 * k[7] +
                a1908 * k[8] +
                a1909 * k[9] + a1910 * k[10] +
                a1911 * k[11] +
                a1912 * k[12] + a1914 * k[14] +
                a1915 * k[15] +
                a1916 * k[16] + a1917 * k[17]
        )
        f(k[19], tmp, p, t + c19 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2001 * k[1] + a2006 * k[6] + a2007 * k[7] +
                a2008 * k[8] +
                a2009 * k[9] + a2010 * k[10] +
                a2011 * k[11] +
                a2012 * k[12] + a2014 * k[14] +
                a2015 * k[15] +
                a2016 * k[16] + a2017 * k[17]
        )
        f(k[20], tmp, p, t + c20 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2101 * k[1] + a2106 * k[6] + a2107 * k[7] +
                a2108 * k[8] +
                a2109 * k[9] + a2110 * k[10] +
                a2111 * k[11] +
                a2112 * k[12] + a2114 * k[14] +
                a2115 * k[15] +
                a2116 * k[16] + a2117 * k[17]
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
        f(k[21], tmp, p, t + c21 * dt)
    end
    return nothing
end

function initialize!(integrator, cache::Vern9ConstantCache)
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 10) : (integrator.kshortsize = 20)
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    return @inbounds for i in eachindex(integrator.k)
        integrator.k[i] = zero(integrator.uprev) ./ oneunit(integrator.t)
    end
end

@muladd function perform_step!(integrator, cache::Vern9ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    T = constvalue(recursive_unitless_bottom_eltype(u))
    T2 = constvalue(typeof(one(t)))
    @OnDemandTableauExtract Vern9Tableau T T2
    k1 = f(uprev, p, t)
    a = dt * a0201
    k2 = f(uprev + a * k1, p, t + c1 * dt)
    k3 = f(uprev + dt * (a0301 * k1 + a0302 * k2), p, t + c2 * dt)
    k4 = f(uprev + dt * (a0401 * k1 + a0403 * k3), p, t + c3 * dt)
    k5 = f(uprev + dt * (a0501 * k1 + a0503 * k3 + a0504 * k4), p, t + c4 * dt)
    k6 = f(uprev + dt * (a0601 * k1 + a0604 * k4 + a0605 * k5), p, t + c5 * dt)
    k7 = f(uprev + dt * (a0701 * k1 + a0704 * k4 + a0705 * k5 + a0706 * k6), p, t + c6 * dt)
    k8 = f(uprev + dt * (a0801 * k1 + a0806 * k6 + a0807 * k7), p, t + c7 * dt)
    k9 = f(uprev + dt * (a0901 * k1 + a0906 * k6 + a0907 * k7 + a0908 * k8), p, t + c8 * dt)
    k10 = f(
        uprev + dt * (a1001 * k1 + a1006 * k6 + a1007 * k7 + a1008 * k8 + a1009 * k9),
        p, t + c9 * dt
    )
    k11 = f(
        uprev +
            dt *
            (a1101 * k1 + a1106 * k6 + a1107 * k7 + a1108 * k8 + a1109 * k9 + a1110 * k10),
        p, t + c10 * dt
    )
    k12 = f(
        uprev +
            dt *
            (
            a1201 * k1 + a1206 * k6 + a1207 * k7 + a1208 * k8 + a1209 * k9 + a1210 * k10 +
                a1211 * k11
        ),
        p,
        t + c11 * dt
    )
    k13 = f(
        uprev +
            dt *
            (
            a1301 * k1 + a1306 * k6 + a1307 * k7 + a1308 * k8 + a1309 * k9 + a1310 * k10 +
                a1311 * k11 + a1312 * k12
        ),
        p,
        t + c12 * dt
    )
    k14 = f(
        uprev +
            dt *
            (
            a1401 * k1 + a1406 * k6 + a1407 * k7 + a1408 * k8 + a1409 * k9 + a1410 * k10 +
                a1411 * k11 + a1412 * k12 + a1413 * k13
        ),
        p,
        t + c13 * dt
    )
    g15 = uprev +
        dt *
        (
        a1501 * k1 + a1506 * k6 + a1507 * k7 + a1508 * k8 + a1509 * k9 + a1510 * k10 +
            a1511 * k11 + a1512 * k12 + a1513 * k13 + a1514 * k14
    )
    g16 = uprev +
        dt *
        (
        a1601 * k1 + a1606 * k6 + a1607 * k7 + a1608 * k8 + a1609 * k9 + a1610 * k10 +
            a1611 * k11 + a1612 * k12 + a1613 * k13
    )
    k15 = f(g15, p, t + dt)
    k16 = f(g16, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 16)
    u = uprev +
        dt * (
        b1 * k1 + b8 * k8 + b9 * k9 + b10 * k10 + b11 * k11 + b12 * k12 + b13 * k13 +
            b14 * k14 + b15 * k15
    )
    if integrator.alg isa CompositeAlgorithm
        integrator.eigen_est = integrator.opts.internalnorm(
            maximum(abs.((k16 .- k15) ./ (g16 .- g15))), t
        )
    end
    if integrator.opts.adaptive
        utilde = dt * (
            btilde1 * k1 + btilde8 * k8 + btilde9 * k9 + btilde10 * k10 +
                btilde11 * k11 + btilde12 * k12 + btilde13 * k13 + btilde14 * k14 +
                btilde15 * k15 + btilde16 * k16
        )
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    # k2, k3,k4,k5,k6,k7 are not used in the code (not even in interpolations), we don't need their pointers.
    # So we mapped k[2] (from integrator) with k8 (from cache), k[3] with k9 and so on.
    integrator.k[1] = k1
    integrator.k[2] = k8
    integrator.k[3] = k9
    integrator.k[4] = k10
    integrator.k[5] = k11
    integrator.k[6] = k12
    integrator.k[7] = k13
    integrator.k[8] = k14
    integrator.k[9] = k15
    integrator.k[10] = k16
    integrator.u = u

    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        @OnDemandTableauExtract Vern9ExtraStages T T2
        k[11] = f(
            uprev +
                dt * (
                a1701 * k[1] + a1708 * k[2] + a1709 * k[3] + a1710 * k[4] +
                    a1711 * k[5] + a1712 * k[6] + a1713 * k[7] + a1714 * k[8] +
                    a1715 * k[9]
            ),
            p, t + c17 * dt
        )
        k[12] = f(
            uprev +
                dt * (
                a1801 * k[1] + a1808 * k[2] + a1809 * k[3] + a1810 * k[4] +
                    a1811 * k[5] + a1812 * k[6] + a1813 * k[7] + a1814 * k[8] +
                    a1815 * k[9] + a1817 * k[11]
            ),
            p,
            t + c18 * dt
        )
        k[13] = f(
            uprev +
                dt * (
                a1901 * k[1] + a1908 * k[2] + a1909 * k[3] + a1910 * k[4] +
                    a1911 * k[5] + a1912 * k[6] + a1913 * k[7] + a1914 * k[8] +
                    a1915 * k[9] + a1917 * k[11] + a1918 * k[12]
            ),
            p,
            t + c19 * dt
        )
        k[14] = f(
            uprev +
                dt * (
                a2001 * k[1] + a2008 * k[2] + a2009 * k[3] + a2010 * k[4] +
                    a2011 * k[5] + a2012 * k[6] + a2013 * k[7] + a2014 * k[8] +
                    a2015 * k[9] + a2017 * k[11] + a2018 * k[12] + a2019 * k[13]
            ),
            p,
            t + c20 * dt
        )
        k[15] = f(
            uprev +
                dt * (
                a2101 * k[1] + a2108 * k[2] + a2109 * k[3] + a2110 * k[4] +
                    a2111 * k[5] + a2112 * k[6] + a2113 * k[7] + a2114 * k[8] +
                    a2115 * k[9] + a2117 * k[11] + a2118 * k[12] + a2119 * k[13] +
                    a2120 * k[14]
            ),
            p,
            t + c21 * dt
        )
        k[16] = f(
            uprev +
                dt * (
                a2201 * k[1] + a2208 * k[2] + a2209 * k[3] + a2210 * k[4] +
                    a2211 * k[5] + a2212 * k[6] + a2213 * k[7] + a2214 * k[8] +
                    a2215 * k[9] + a2217 * k[11] + a2218 * k[12] + a2219 * k[13] +
                    a2220 * k[14] + a2221 * k[15]
            ),
            p,
            t + c22 * dt
        )
        k[17] = f(
            uprev +
                dt * (
                a2301 * k[1] + a2308 * k[2] + a2309 * k[3] + a2310 * k[4] +
                    a2311 * k[5] + a2312 * k[6] + a2313 * k[7] + a2314 * k[8] +
                    a2315 * k[9] + a2317 * k[11] + a2318 * k[12] + a2319 * k[13] +
                    a2320 * k[14] + a2321 * k[15]
            ),
            p,
            t + c23 * dt
        )
        k[18] = f(
            uprev +
                dt * (
                a2401 * k[1] + a2408 * k[2] + a2409 * k[3] + a2410 * k[4] +
                    a2411 * k[5] + a2412 * k[6] + a2413 * k[7] + a2414 * k[8] +
                    a2415 * k[9] + a2417 * k[11] + a2418 * k[12] + a2419 * k[13] +
                    a2420 * k[14] + a2421 * k[15]
            ),
            p,
            t + c24 * dt
        )
        k[19] = f(
            uprev +
                dt * (
                a2501 * k[1] + a2508 * k[2] + a2509 * k[3] + a2510 * k[4] +
                    a2511 * k[5] + a2512 * k[6] + a2513 * k[7] + a2514 * k[8] +
                    a2515 * k[9] + a2517 * k[11] + a2518 * k[12] + a2519 * k[13] +
                    a2520 * k[14] + a2521 * k[15]
            ),
            p,
            t + c25 * dt
        )
        k[20] = f(
            uprev +
                dt * (
                a2601 * k[1] + a2608 * k[2] + a2609 * k[3] + a2610 * k[4] +
                    a2611 * k[5] + a2612 * k[6] + a2613 * k[7] + a2614 * k[8] +
                    a2615 * k[9] + a2617 * k[11] + a2618 * k[12] + a2619 * k[13] +
                    a2620 * k[14] + a2621 * k[15]
            ),
            p,
            t + c26 * dt
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
    end
end

function initialize!(integrator, cache::Vern9Cache)
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, k14, k15, k16) = cache
    (; k) = integrator
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 10) : (integrator.kshortsize = 20)
    resize!(k, integrator.kshortsize)
    # k2, k3,k4,k5,k6,k7 are not used in the code (not even in interpolations), we don't need their pointers.
    # So we mapped k[2] (from integrator) with k8 (from cache), k[3] with k9 and so on.
    k[1] = k1
    k[2] = k8
    k[3] = k9
    k[4] = k10
    k[5] = k11
    k[6] = k12
    k[7] = k13
    k[8] = k14
    k[9] = k15
    k[10] = k16 # Setup pointers

    return if !_unwrap_val(cache.lazy)
        for i in 11:20
            k[i] = similar(cache.k1)
        end
    end
end

@muladd function perform_step!(integrator, cache::Vern9Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    uidx = eachindex(integrator.uprev)
    T = constvalue(recursive_unitless_bottom_eltype(u))
    T2 = constvalue(typeof(one(t)))
    @OnDemandTableauExtract Vern9Tableau T T2
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, k14, k15, k16, utilde, tmp, rtmp, atmp, stage_limiter!, step_limiter!, thread) = cache
    f(k1, uprev, p, t)
    a = dt * a0201
    @.. broadcast = false thread = thread tmp = uprev + a * k1
    stage_limiter!(tmp, integrator, p, t + c1 * dt)
    f(k2, tmp, p, t + c1 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a0301 * k1 + a0302 * k2)
    stage_limiter!(tmp, integrator, p, t + c2 * dt)
    f(k3, tmp, p, t + c2 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a0401 * k1 + a0403 * k3)
    stage_limiter!(tmp, integrator, p, t + c3 * dt)
    f(k4, tmp, p, t + c3 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (a0501 * k1 + a0503 * k3 + a0504 * k4)
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k5, tmp, p, t + c4 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (a0601 * k1 + a0604 * k4 + a0605 * k5)
    stage_limiter!(tmp, integrator, p, t + c5 * dt)
    f(k6, tmp, p, t + c5 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a0701 * k1 + a0704 * k4 + a0705 * k5 +
            a0706 * k6
    )
    stage_limiter!(tmp, integrator, p, t + c6 * dt)
    f(k7, tmp, p, t + c6 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (a0801 * k1 + a0806 * k6 + a0807 * k7)
    stage_limiter!(tmp, integrator, p, t + c7 * dt)
    f(k8, tmp, p, t + c7 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a0901 * k1 + a0906 * k6 + a0907 * k7 +
            a0908 * k8
    )
    stage_limiter!(tmp, integrator, p, t + c8 * dt)
    f(k9, tmp, p, t + c8 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt *
        (
        a1001 * k1 + a1006 * k6 + a1007 * k7 +
            a1008 * k8 + a1009 * k9
    )
    stage_limiter!(tmp, integrator, p, t + c9 * dt)
    f(k10, tmp, p, t + c9 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1101 * k1 + a1106 * k6 + a1107 * k7 +
            a1108 * k8 +
            a1109 * k9 + a1110 * k10
    )
    stage_limiter!(tmp, integrator, p, t + c10 * dt)
    f(k11, tmp, p, t + c10 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1201 * k1 + a1206 * k6 + a1207 * k7 +
            a1208 * k8 +
            a1209 * k9 + a1210 * k10 + a1211 * k11
    )
    stage_limiter!(tmp, integrator, p, t + c11 * dt)
    f(k12, tmp, p, t + c11 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1301 * k1 + a1306 * k6 + a1307 * k7 +
            a1308 * k8 +
            a1309 * k9 + a1310 * k10 + a1311 * k11 +
            a1312 * k12
    )
    stage_limiter!(tmp, integrator, p, t + c12 * dt)
    f(k13, tmp, p, t + c12 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1401 * k1 + a1406 * k6 + a1407 * k7 +
            a1408 * k8 +
            a1409 * k9 + a1410 * k10 + a1411 * k11 +
            a1412 * k12 +
            a1413 * k13
    )
    stage_limiter!(tmp, integrator, p, t + c13 * dt)
    f(k14, tmp, p, t + c13 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        a1501 * k1 + a1506 * k6 + a1507 * k7 +
            a1508 * k8 +
            a1509 * k9 + a1510 * k10 + a1511 * k11 +
            a1512 * k12 +
            a1513 * k13 + a1514 * k14
    )
    stage_limiter!(tmp, integrator, p, t + dt)
    f(k15, tmp, p, t + dt)
    @.. broadcast = false thread = thread u = uprev +
        dt *
        (
        a1601 * k1 + a1606 * k6 + a1607 * k7 + a1608 * k8 +
            a1609 * k9 +
            a1610 * k10 + a1611 * k11 + a1612 * k12 +
            a1613 * k13
    )
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    f(k16, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 16)
    if integrator.alg isa CompositeAlgorithm
        g16 = u
        g15 = tmp
        @.. broadcast = false thread = thread rtmp = abs((k16 - k15) / (g16 - g15))
        integrator.eigen_est = integrator.opts.internalnorm(norm(rtmp, Inf), t)
    end
    @.. broadcast = false thread = thread u = uprev +
        dt *
        (
        b1 * k1 + b8 * k8 + b9 * k9 + b10 * k10 +
            b11 * k11 + b12 * k12 +
            b13 * k13 + b14 * k14 + b15 * k15
    )
    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = dt * (
            btilde1 * k1 + btilde8 * k8 +
                btilde9 * k9 +
                btilde10 * k10 + btilde11 * k11 +
                btilde12 * k12 +
                btilde13 * k13 + btilde14 * k14 +
                btilde15 * k15 +
                btilde16 * k16
        )
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    alg = unwrap_alg(integrator, false)
    if !_unwrap_val(cache.lazy) && (
            integrator.opts.adaptive == false ||
                accept_step_controller(integrator, integrator.opts.controller)
        )
        k = integrator.k
        (; tmp) = cache
        @OnDemandTableauExtract Vern9ExtraStages T T2
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1701 * k[1] + a1708 * k[2] + a1709 * k[3] +
                a1710 * k[4] +
                a1711 * k[5] + a1712 * k[6] + a1713 * k[7] +
                a1714 * k[8] +
                a1715 * k[9]
        )
        f(k[11], tmp, p, t + c17 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1801 * k[1] + a1808 * k[2] + a1809 * k[3] +
                a1810 * k[4] +
                a1811 * k[5] + a1812 * k[6] + a1813 * k[7] +
                a1814 * k[8] +
                a1815 * k[9] + a1817 * k[11]
        )
        f(k[12], tmp, p, t + c18 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a1901 * k[1] + a1908 * k[2] + a1909 * k[3] +
                a1910 * k[4] +
                a1911 * k[5] + a1912 * k[6] + a1913 * k[7] +
                a1914 * k[8] +
                a1915 * k[9] + a1917 * k[11] + a1918 * k[12]
        )
        f(k[13], tmp, p, t + c19 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2001 * k[1] + a2008 * k[2] + a2009 * k[3] +
                a2010 * k[4] +
                a2011 * k[5] + a2012 * k[6] + a2013 * k[7] +
                a2014 * k[8] +
                a2015 * k[9] + a2017 * k[11] +
                a2018 * k[12] +
                a2019 * k[13]
        )
        f(k[14], tmp, p, t + c20 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2101 * k[1] + a2108 * k[2] + a2109 * k[3] +
                a2110 * k[4] +
                a2111 * k[5] + a2112 * k[6] + a2113 * k[7] +
                a2114 * k[8] +
                a2115 * k[9] + a2117 * k[11] +
                a2118 * k[12] +
                a2119 * k[13] + a2120 * k[14]
        )
        f(k[15], tmp, p, t + c21 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2201 * k[1] + a2208 * k[2] + a2209 * k[3] +
                a2210 * k[4] +
                a2211 * k[5] + a2212 * k[6] + a2213 * k[7] +
                a2214 * k[8] +
                a2215 * k[9] + a2217 * k[11] +
                a2218 * k[12] +
                a2219 * k[13] + a2220 * k[14] +
                a2221 * k[15]
        )
        f(k[16], tmp, p, t + c22 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2301 * k[1] + a2308 * k[2] + a2309 * k[3] +
                a2310 * k[4] +
                a2311 * k[5] + a2312 * k[6] + a2313 * k[7] +
                a2314 * k[8] +
                a2315 * k[9] + a2317 * k[11] +
                a2318 * k[12] +
                a2319 * k[13] + a2320 * k[14] +
                a2321 * k[15]
        )
        f(k[17], tmp, p, t + c23 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2401 * k[1] + a2408 * k[2] + a2409 * k[3] +
                a2410 * k[4] +
                a2411 * k[5] + a2412 * k[6] + a2413 * k[7] +
                a2414 * k[8] +
                a2415 * k[9] + a2417 * k[11] +
                a2418 * k[12] +
                a2419 * k[13] + a2420 * k[14] +
                a2421 * k[15]
        )
        f(k[18], tmp, p, t + c24 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2501 * k[1] + a2508 * k[2] + a2509 * k[3] +
                a2510 * k[4] +
                a2511 * k[5] + a2512 * k[6] + a2513 * k[7] +
                a2514 * k[8] +
                a2515 * k[9] + a2517 * k[11] +
                a2518 * k[12] +
                a2519 * k[13] + a2520 * k[14] +
                a2521 * k[15]
        )
        f(k[19], tmp, p, t + c25 * dt)
        @.. broadcast = false thread = thread tmp = uprev +
            dt *
            (
            a2601 * k[1] + a2608 * k[2] + a2609 * k[3] +
                a2610 * k[4] +
                a2611 * k[5] + a2612 * k[6] + a2613 * k[7] +
                a2614 * k[8] +
                a2615 * k[9] + a2617 * k[11] +
                a2618 * k[12] +
                a2619 * k[13] + a2620 * k[14] +
                a2621 * k[15]
        )
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
        f(k[20], tmp, p, t + c26 * dt)
    end
    return nothing
end

function initialize!(integrator, cache::RKV76IIaConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 10) : (integrator.kshortsize = 10)
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = zero(integrator.fsalfirst)
    @inbounds for i in 2:(integrator.kshortsize - 1)
        integrator.k[i] = zero(integrator.fsalfirst)
    end
    return integrator.k[integrator.kshortsize] = zero(integrator.fsallast)
end

@muladd function perform_step!(integrator, cache::RKV76IIaConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        c1, c2, c3, c4, c5, c6, c7, c8, c9, c10,
        a21, a31, a32, a41, a42, a43, a51, a52, a53, a54,
        a61, a62, a63, a64, a65, a71, a72, a73, a74, a75, a76,
        a81, a82, a83, a84, a85, a86, a87,
        a91, a92, a93, a94, a95, a96, a97, a98,
        a101, a102, a103, a104, a105, a106, a107, a108, a109,
        b1, b2, b3, b4, b5, b6, b7, b8, b9, b10,
        bh1, bh2, bh3, bh4, bh5, bh6, bh7, bh8, bh9, bh10,
    ) = cache.tab

    k1 = f(uprev, p, t)
    k2 = f(uprev + dt * a21 * k1, p, t + c2 * dt)
    k3 = f(uprev + dt * (a31 * k1 + a32 * k2), p, t + c3 * dt)
    k4 = f(uprev + dt * (a41 * k1 + a42 * k2 + a43 * k3), p, t + c4 * dt)
    k5 = f(uprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4), p, t + c5 * dt)
    k6 = f(uprev + dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4 + a65 * k5), p, t + c6 * dt)
    k7 = f(uprev + dt * (a71 * k1 + a72 * k2 + a73 * k3 + a74 * k4 + a75 * k5 + a76 * k6), p, t + c7 * dt)
    k8 = f(uprev + dt * (a81 * k1 + a82 * k2 + a83 * k3 + a84 * k4 + a85 * k5 + a86 * k6 + a87 * k7), p, t + c8 * dt)
    k9 = f(uprev + dt * (a91 * k1 + a92 * k2 + a93 * k3 + a94 * k4 + a95 * k5 + a96 * k6 + a97 * k7 + a98 * k8), p, t + c9 * dt)
    k10 = f(uprev + dt * (a101 * k1 + a102 * k2 + a103 * k3 + a104 * k4 + a105 * k5 + a106 * k6 + a107 * k7 + a108 * k8 + a109 * k9), p, t + c10 * dt)

    u = uprev + dt * (b1 * k1 + b2 * k2 + b3 * k3 + b4 * k4 + b5 * k5 + b6 * k6 + b7 * k7 + b8 * k8 + b9 * k9 + b10 * k10)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)

    if integrator.opts.adaptive
        uhat = uprev + dt * (bh1 * k1 + bh2 * k2 + bh3 * k3 + bh4 * k4 + bh5 * k5 + bh6 * k6 + bh7 * k7 + bh8 * k8 + bh9 * k9 + bh10 * k10)
        atmp = calculate_residuals(
            u .- uhat, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    integrator.k[1] = k1
    integrator.k[2] = k2
    integrator.k[3] = k3
    integrator.k[4] = k4
    integrator.k[5] = k5
    integrator.k[6] = k6
    integrator.k[7] = k7
    integrator.k[8] = k8
    integrator.k[9] = k9
    integrator.k[10] = k10

    integrator.u = u
end

function initialize!(integrator, cache::RKV76IIaCache)
    alg = unwrap_alg(integrator, false)
    _unwrap_val(cache.lazy) ? (integrator.kshortsize = 10) : (integrator.kshortsize = 10)
    (; k) = integrator
    resize!(k, integrator.kshortsize)
    k[1] = cache.k1
    k[2] = cache.k2
    k[3] = cache.k3
    k[4] = cache.k4
    k[5] = cache.k5
    k[6] = cache.k6
    k[7] = cache.k7
    k[8] = cache.k8
    k[9] = cache.k9
    return k[10] = cache.k10
end

@muladd function perform_step!(integrator, cache::RKV76IIaCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        c1, c2, c3, c4, c5, c6, c7, c8, c9, c10,
        a21, a31, a32, a41, a42, a43, a51, a52, a53, a54,
        a61, a62, a63, a64, a65, a71, a72, a73, a74, a75, a76,
        a81, a82, a83, a84, a85, a86, a87,
        a91, a92, a93, a94, a95, a96, a97, a98,
        a101, a102, a103, a104, a105, a106, a107, a108, a109,
        b1, b2, b3, b4, b5, b6, b7, b8, b9, b10,
        bh1, bh2, bh3, bh4, bh5, bh6, bh7, bh8, bh9, bh10,
    ) = cache.tab
    (; k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, utilde, tmp, atmp) = cache
    (; thread) = cache

    f(k1, uprev, p, t)
    @.. broadcast = false thread = thread tmp = uprev + dt * a21 * k1
    f(k2, tmp, p, t + c2 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a31 * k1 + a32 * k2)
    f(k3, tmp, p, t + c3 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a41 * k1 + a42 * k2 + a43 * k3)
    f(k4, tmp, p, t + c4 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a51 * k1 + a52 * k2 + a53 * k3 + a54 * k4)
    f(k5, tmp, p, t + c5 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a61 * k1 + a62 * k2 + a63 * k3 + a64 * k4 + a65 * k5)
    f(k6, tmp, p, t + c6 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a71 * k1 + a72 * k2 + a73 * k3 + a74 * k4 + a75 * k5 + a76 * k6)
    f(k7, tmp, p, t + c7 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a81 * k1 + a82 * k2 + a83 * k3 + a84 * k4 + a85 * k5 + a86 * k6 + a87 * k7)
    f(k8, tmp, p, t + c8 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a91 * k1 + a92 * k2 + a93 * k3 + a94 * k4 + a95 * k5 + a96 * k6 + a97 * k7 + a98 * k8)
    f(k9, tmp, p, t + c9 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (a101 * k1 + a102 * k2 + a103 * k3 + a104 * k4 + a105 * k5 + a106 * k6 + a107 * k7 + a108 * k8 + a109 * k9)
    f(k10, tmp, p, t + c10 * dt)

    @.. broadcast = false thread = thread u = uprev + dt * (b1 * k1 + b2 * k2 + b3 * k3 + b4 * k4 + b5 * k5 + b6 * k6 + b7 * k7 + b8 * k8 + b9 * k9 + b10 * k10)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)

    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = uprev + dt * (bh1 * k1 + bh2 * k2 + bh3 * k3 + bh4 * k4 + bh5 * k5 + bh6 * k6 + bh7 * k7 + bh8 * k8 + bh9 * k9 + bh10 * k10)
        @.. broadcast = false thread = thread atmp = u - utilde
        calculate_residuals!(
            atmp, atmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t, thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

using OrdinaryDiffEqVerner, OrdinaryDiffEqCore, OrdinaryDiffEqExplicitRK
using DiffEqDevTools, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear, prob_ode_bigfloatlinear, prob_ode_bigfloat2Dlinear

# Problem mappings
const probbig = prob_ode_bigfloat2Dlinear
const probnumbig = prob_ode_bigfloatlinear
const probnum = prob_ode_linear
const prob = prob_ode_2Dlinear

testTol = 2.0

# Custom ODE functions for testing
function f!(du, u, p, t)
    return du[1] = -u[1]
end

function f(u, p, t)
    return -u
end

t_end = 64.0
setprecision(256)
prob_oop = ODEProblem(ODEFunction(f; analytic = (u0, p, t) -> exp(-t)), 1.0, (0.0, t_end))
prob_iip = ODEProblem(ODEFunction(f!; analytic = (u0, p, t) -> [exp(-t)]), [1.0], (0.0, t_end))

# -------------------------------------------------------------
# Helper for convergence test consistency
function check_convergence(dts, prob, alg, order_expected)
    # Use DiffEqDevTools for overall convergence estimate
    sim = test_convergence(dts, prob, alg)
    return @test (sim.𝒪est[:final] > order_expected) || (abs(sim.𝒪est[:final] - order_expected) < testTol)

end
# -------------------------------------------------------------

### Vern6
println("Vern6")
dts = (1 / 2) .^ (8:-1:5)
check_convergence(dts, probnumbig, Vern6(), 6)
check_convergence(dts, probbig, Vern6(), 6)

tabalg = ExplicitRK(tableau = constructVernerEfficient6(BigFloat))
sol1 = solve(probnumbig, Vern6(); dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg; dt = 1 / 2^6, adaptive = false, save_everystep = false)
@test sol1.u[end] - sol2.u[end] < 1.0e-10

sol1 = solve(probbig, Vern6(); dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg; dt = 1 / 2^3, adaptive = false, save_everystep = false)
@test minimum(sol1.u[end] - sol2.u[end] .< 1.0e-10)

sol1 = solve(probbig, tabalg; dt = 1 / 2^6)
sol2 = solve(probbig, Vern6(); dt = 1 / 2^6)
@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

# -------------------------------------------------------------
### Vern7
println("Vern7")
dts = (1 / 2) .^ (6:-1:3)
check_convergence(dts, probnumbig, Vern7(), 7)
check_convergence(dts, probbig, Vern7(), 7)

tabalg = ExplicitRK(tableau = constructVerner7(BigFloat))
sol1 = solve(probnumbig, Vern7(); dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg; dt = 1 / 2^6, adaptive = false, save_everystep = false)
@test sol1.u[end] - sol2.u[end] < 1.0e-10

sol1 = solve(probbig, Vern7(); dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg; dt = 1 / 2^3, adaptive = false, save_everystep = false)
@test minimum(sol1.u[end] - sol2.u[end] .< 1.0e-10)

sol1 = solve(probbig, tabalg; dt = 1 / 2^6)
sol2 = solve(probbig, Vern7(); dt = 1 / 2^6)
@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

# -------------------------------------------------------------
### Vern8
println("Vern8")
dts = (1 / 2) .^ (6:-1:3)
check_convergence(dts, probnumbig, Vern8(), 8)
check_convergence(dts, probbig, Vern8(), 8)

tabalg = ExplicitRK(tableau = constructVerner8(BigFloat))
sol1 = solve(probnumbig, Vern8(); dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg; dt = 1 / 2^6, adaptive = false, save_everystep = false)
@test sol1.u[end] - sol2.u[end] < 1.0e-10

sol1 = solve(probbig, Vern8(); dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg; dt = 1 / 2^3, adaptive = false, save_everystep = false)
@test minimum(sol1.u[end] - sol2.u[end] .< 1.0e-10)

sol1 = solve(prob, tabalg; dt = 1 / 2^6)
sol2 = solve(prob, Vern8(); dt = 1 / 2^6)
@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

# -------------------------------------------------------------
### Vern9
println("Vern9")
dts = (1 / 2) .^ (6:-1:3)
check_convergence(dts, probnumbig, Vern9(), 9)
check_convergence(dts, probbig, Vern9(), 9)

tabalg = ExplicitRK(tableau = constructVernerEfficient9(BigFloat))
sol1 = solve(probnumbig, Vern9(); dt = 1 / 2^6, adaptive = false, save_everystep = false)
sol2 = solve(probnumbig, tabalg; dt = 1 / 2^6, adaptive = false, save_everystep = false)
@test abs(sol1.u[end] - sol2.u[end]) < 1.0e-15

sol1 = solve(probbig, Vern9(); dt = 1 / 2^3, adaptive = false, save_everystep = false)
sol2 = solve(probbig, tabalg; dt = 1 / 2^3, adaptive = false, save_everystep = false)
@test minimum(abs.(sol1.u[end] - sol2.u[end]) .< 1.0e-15)

sol1 = solve(probbig, tabalg; dt = 1 / 2^6)
sol2 = solve(probbig, Vern9(); dt = 1 / 2^6)
@test length(sol1) == length(sol2)
@test SciMLBase.successful_retcode(sol1)
@test SciMLBase.successful_retcode(sol2)

# -------------------------------------------------------------
### RKV76IIa
println("RKV76IIa")
# dts = [1, 0.5, 0.25, 0.125, 0.0625, 0.03125, 0.015625, 0.0078125, 0.00390625, 0.001953125, 0.0009765625, 0.00048828125, 0.000244140625, 0.0001220703125, 0.00006103515625]
dts = [2, 1, 0.5, 0.25]

check_convergence(dts, prob_oop, RKV76IIa(), 7)

# -------------------------------------------------------------
### Backward solve lazy interpolation dt sign regression test
# Tests that lazy interpolation during a backward solve produces correct results.
# Previously, modify_dt_for_tstops! stored dtpropose without the sign, causing
# addsteps! to evaluate at times outside the step interval on the last step.
println("Backward solve lazy interpolation")

function backward_ode!(du, u, p, t)
    du[1] = -u[1]
    return du[2] = -2 * u[2]
end

prob_back = ODEProblem(backward_ode!, [1.0, 1.0], (1.0, 0.0))

interp_lazy = Float64[]
interp_nolazy = Float64[]

cb_lazy = DiscreteCallback(
    (u, t, int) -> true,
    integrator -> begin
        t_mid = (integrator.tprev + integrator.t) / 2
        curu = similar(integrator.u)
        integrator(curu, t_mid)
        push!(interp_lazy, curu[1])
        u_modified!(integrator, false)
    end,
    save_positions = (false, false)
)

cb_nolazy = DiscreteCallback(
    (u, t, int) -> true,
    integrator -> begin
        t_mid = (integrator.tprev + integrator.t) / 2
        curu = similar(integrator.u)
        integrator(curu, t_mid)
        push!(interp_nolazy, curu[1])
        u_modified!(integrator, false)
    end,
    save_positions = (false, false)
)

solve(
    prob_back, Vern9(lazy = true), abstol = 1.0e-12, reltol = 1.0e-12,
    callback = cb_lazy, save_everystep = false
)
solve(
    prob_back, Vern9(lazy = false), abstol = 1.0e-12, reltol = 1.0e-12,
    callback = cb_nolazy, save_everystep = false
)

@test length(interp_lazy) == length(interp_nolazy)
@test maximum(abs.(interp_lazy .- interp_nolazy)) < 1.0e-10

module OrdinaryDiffEqVerner

import OrdinaryDiffEqCore: alg_order, calculate_residuals!,
    initialize!, perform_step!, unwrap_alg,
    calculate_residuals, alg_stability_size,
    OrdinaryDiffEqAlgorithm,
    CompositeAlgorithm, accept_step_controller,
    OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache,
    OrdinaryDiffEqAdaptiveAlgorithm, CompiledFloats, uses_uprev,
    alg_cache, _vec, _reshape, @cache, isfsal, full_cache,
    constvalue, _unwrap_val,
    explicit_rk_docstring, trivial_limiter!, _ode_interpolant,
    _ode_interpolant!, _ode_addsteps!, @fold,
    @OnDemandTableauExtract, AutoAlgSwitch,
    DerivativeOrderNotPossibleError,
    get_fsalfirstlast, copyat_or_push!
using FastBroadcast, Polyester, MuladdMacro, RecursiveArrayTools
using DiffEqBase: @def, @tight_loop_macros
using Static: False
using TruncatedStacktraces: @truncate_stacktrace
using LinearAlgebra: norm
import OrdinaryDiffEqCore
using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("verner_tableaus.jl")
include("verner_caches.jl")
include("verner_addsteps.jl")
include("interp_func.jl")
include("interpolants.jl")
include("verner_rk_perform_step.jl")

import PrecompileTools
import Preferences
PrecompileTools.@compile_workload begin
    lorenz = OrdinaryDiffEqCore.lorenz
    lorenz_oop = OrdinaryDiffEqCore.lorenz_oop
    solver_list = [Vern6(), Vern7(), Vern8(), Vern9()]
    prob_list = []

    if Preferences.@load_preference("PrecompileDefaultSpecialize", true)
        push!(prob_list, ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0)))
        push!(prob_list, ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0), Float64[]))
    end

    if Preferences.@load_preference("PrecompileAutoSpecialize", false)
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.AutoSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0)
            )
        )
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.AutoSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0), Float64[]
            )
        )
    end

    if Preferences.@load_preference("PrecompileFunctionWrapperSpecialize", false)
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.FunctionWrapperSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0)
            )
        )
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.FunctionWrapperSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0), Float64[]
            )
        )
    end

    if Preferences.@load_preference("PrecompileNoSpecialize", false)
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.NoSpecialize}(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0))
        )
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.NoSpecialize}(
                lorenz, [1.0; 0.0; 0.0], (0.0, 1.0),
                Float64[]
            )
        )
    end

    for prob in prob_list, solver in solver_list
        solve(prob, solver)(5.0)
    end

    prob_list = nothing
    solver_list = nothing
end

export Vern6, Vern7, Vern8, Vern9, RKV76IIa
export AutoVern6, AutoVern7, AutoVern8, AutoVern9

end

isfsal(alg::Vern7) = false
isfsal(alg::Vern8) = false
isfsal(alg::Vern9) = false
isfsal(alg::RKV76IIa) = false

alg_order(alg::Vern6) = 6
alg_order(alg::Vern7) = 7
alg_order(alg::Vern8) = 8
alg_order(alg::Vern9) = 9
alg_order(alg::RKV76IIa) = 7

alg_stability_size(alg::Vern6) = 4.8553
alg_stability_size(alg::Vern7) = 4.64
alg_stability_size(alg::Vern8) = 5.8641
alg_stability_size(alg::Vern9) = 4.4762
alg_stability_size(alg::RKV76IIa) = 4.910807773  # From the file: Real Stability Interval is nearly [ -4.910807773, 0]

SciMLBase.has_lazy_interpolation(alg::Union{Vern6, Vern7, Vern8, Vern9, RKV76IIa}) = _unwrap_val(alg.lazy)

@doc explicit_rk_docstring(
    "Verner's most efficient 6/5 method (lazy 6th order interpolant).",
    "Vern6",
    references = "@article{verner2010numerically,
    title={Numerically optimal Runge--Kutta pairs with interpolants},
    author={Verner, James H},
    journal={Numerical Algorithms},
    volume={53},
    number={2-3},
    pages={383--396},
    year={2010},
    publisher={Springer}
    }",
    extra_keyword_description = """- `lazy`: determines if the lazy interpolant is used.
    """,
    extra_keyword_default = "lazy = true"
)
Base.@kwdef struct Vern6{StageLimiter, StepLimiter, Thread, L} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    lazy::L = Val{true}()
end
@truncate_stacktrace Vern6 3
# Convert Bool lazy to Val for backwards compatibility
function Vern6(sl::SL, stl::STL, th::TH, lazy::Bool) where {SL, STL, TH}
    return Vern6{SL, STL, TH, Val{lazy}}(sl, stl, th, Val{lazy}())
end
# for backwards compatibility
function Vern6(stage_limiter!, step_limiter! = trivial_limiter!; lazy = true)
    return Vern6(stage_limiter!, step_limiter!, False(), lazy)
end

@doc explicit_rk_docstring(
    "Verner's most efficient 7/6 method (lazy 7th order interpolant). Good for problems requiring high accuracy. Slightly more computationally expensive than Tsit5. Performance best when parameter vector remains unchanged. Recommended for high-accuracy non-stiff problems.",
    "Vern7",
    references = "@article{verner2010numerically,
    title={Numerically optimal Runge--Kutta pairs with interpolants},
    author={Verner, James H},
    journal={Numerical Algorithms},
    volume={53},
    number={2-3},
    pages={383--396},
    year={2010},
    publisher={Springer}
    }",
    extra_keyword_description = """- `lazy`: determines if the lazy interpolant is used.
    """,
    extra_keyword_default = "lazy = true"
)
Base.@kwdef struct Vern7{StageLimiter, StepLimiter, Thread, L} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    lazy::L = Val{true}()
end
@truncate_stacktrace Vern7 3
# Convert Bool lazy to Val for backwards compatibility
function Vern7(sl::SL, stl::STL, th::TH, lazy::Bool) where {SL, STL, TH}
    return Vern7{SL, STL, TH, Val{lazy}}(sl, stl, th, Val{lazy}())
end
# for backwards compatibility
function Vern7(stage_limiter!, step_limiter! = trivial_limiter!; lazy = true)
    return Vern7(stage_limiter!, step_limiter!, False(), lazy)
end

@doc explicit_rk_docstring(
    "Verner's most efficient 8/7 method (lazy 8th order interpolant).",
    "Vern8",
    references = "@article{verner2010numerically,
    title={Numerically optimal Runge--Kutta pairs with interpolants},
    author={Verner, James H},
    journal={Numerical Algorithms},
    volume={53},
    number={2-3},
    pages={383--396},
    year={2010},
    publisher={Springer}
    }",
    extra_keyword_description = """- `lazy`: determines if the lazy interpolant is used.
    """,
    extra_keyword_default = "lazy = true"
)
Base.@kwdef struct Vern8{StageLimiter, StepLimiter, Thread, L} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    lazy::L = Val{true}()
end
@truncate_stacktrace Vern8 3
# Convert Bool lazy to Val for backwards compatibility
function Vern8(sl::SL, stl::STL, th::TH, lazy::Bool) where {SL, STL, TH}
    return Vern8{SL, STL, TH, Val{lazy}}(sl, stl, th, Val{lazy}())
end
# for backwards compatibility
function Vern8(stage_limiter!, step_limiter! = trivial_limiter!; lazy = true)
    return Vern8(stage_limiter!, step_limiter!, False(), lazy)
end

@doc explicit_rk_docstring(
    "Verner's most efficient 9/8 method (lazy 9th order interpolant).",
    "Vern9",
    references = "@article{verner2010numerically,
    title={Numerically optimal Runge--Kutta pairs with interpolants},
    author={Verner, James H},
    journal={Numerical Algorithms},
    volume={53},
    number={2-3},
    pages={383--396},
    year={2010},
    publisher={Springer}
    }",
    extra_keyword_description = """- `lazy`: determines if the lazy interpolant is used.
    """, extra_keyword_default = "lazy = true"
)
Base.@kwdef struct Vern9{StageLimiter, StepLimiter, Thread, L} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    lazy::L = Val{true}()
end
@truncate_stacktrace Vern9 3
# Convert Bool lazy to Val for backwards compatibility
function Vern9(sl::SL, stl::STL, th::TH, lazy::Bool) where {SL, STL, TH}
    return Vern9{SL, STL, TH, Val{lazy}}(sl, stl, th, Val{lazy}())
end
# for backwards compatibility
function Vern9(stage_limiter!, step_limiter! = trivial_limiter!; lazy = true)
    return Vern9(stage_limiter!, step_limiter!, False(), lazy)
end

"""
Automatic switching algorithm that can switch between the (non-stiff) `Vern6()` and `stiff_alg`.

    AutoVern6(stiff_alg; kwargs...)

This method is equivalent to `AutoAlgSwitch(Vern6(), stiff_alg; kwargs...)`.
To gain access to stiff algorithms you might have to install additional libraries,
such as `OrdinaryDiffEqRosenbrock`.
"""
AutoVern6(alg; lazy = true, kwargs...) = AutoAlgSwitch(Vern6(lazy = lazy), alg; kwargs...)
"""
Automatic switching algorithm that can switch between the (non-stiff) `Vern7()` and `stiff_alg`.

    AutoVern7(stiff_alg; kwargs...)

This method is equivalent to `AutoAlgSwitch(Vern7(), stiff_alg; kwargs...)`.
To gain access to stiff algorithms you might have to install additional libraries,
such as `OrdinaryDiffEqRosenbrock`.
"""
AutoVern7(alg; lazy = true, kwargs...) = AutoAlgSwitch(Vern7(lazy = lazy), alg; kwargs...)
"""
Automatic switching algorithm that can switch between the (non-stiff) `Vern8()` and `stiff_alg`.

    AutoVern8(stiff_alg; kwargs...)

This method is equivalent to `AutoAlgSwitch(Vern8(), stiff_alg; kwargs...)`.
To gain access to stiff algorithms you might have to install additional libraries,
such as `OrdinaryDiffEqRosenbrock`.
"""
AutoVern8(alg; lazy = true, kwargs...) = AutoAlgSwitch(Vern8(lazy = lazy), alg; kwargs...)
"""
Automatic switching algorithm that can switch between the (non-stiff) `Vern9()` and `stiff_alg`.

    AutoVern9(stiff_alg; kwargs...)

This method is equivalent to `AutoAlgSwitch(Vern9(), stiff_alg; kwargs...)`.
To gain access to stiff algorithms you might have to install additional libraries,
such as `OrdinaryDiffEqRosenbrock`.
"""
AutoVern9(alg; lazy = true, kwargs...) = AutoAlgSwitch(Vern9(lazy = lazy), alg; kwargs...)


@doc explicit_rk_docstring(
    "Verner's RKV76.IIa 7/6 method. Most efficient 10-stage conventional pair of orders 6 and 7 with interpolants.",
    "RKV76IIa",
    references = "@misc{verner2024rkv76iia,
    title={RKV76.IIa - A 'most efficient' Runge--Kutta (10:7(6)) pair},
    author={Verner, James H},
    year={2024},
    url={https://www.sfu.ca/~jverner/RKV76.IIa.Efficient.000003389335684.240711.FLOAT6040OnWeb}
    }",
    extra_keyword_description = """- `lazy`: determines if the lazy interpolant is used.
    """,
    extra_keyword_default = "lazy = true"
)
Base.@kwdef struct RKV76IIa{StageLimiter, StepLimiter, Thread, L} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    lazy::L = Val{true}()
end
@truncate_stacktrace RKV76IIa 3
# Convert Bool lazy to Val for backwards compatibility
function RKV76IIa(sl::SL, stl::STL, th::TH, lazy::Bool) where {SL, STL, TH}
    return RKV76IIa{SL, STL, TH, Val{lazy}}(sl, stl, th, Val{lazy}())
end
# for backwards compatibility
function RKV76IIa(stage_limiter!, step_limiter! = trivial_limiter!; lazy = true)
    return RKV76IIa(stage_limiter!, step_limiter!, False(), lazy)
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        Union{
            Vern6Cache, Vern6ConstantCache,
        },
    }
    return dense ? "specialized 6th order lazy interpolation" : "1st order linear"
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        Union{
            Vern7Cache, Vern7ConstantCache,
        },
    }
    return dense ? "specialized 7th order lazy interpolation" : "1st order linear"
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        Union{
            Vern8Cache, Vern8ConstantCache,
        },
    }
    return dense ? "specialized 8th order lazy interpolation" : "1st order linear"
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        Union{
            Vern9Cache, Vern9ConstantCache,
        },
    }
    return dense ? "specialized 9th order lazy interpolation" : "1st order linear"
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        Union{
            RKV76IIaCache, RKV76IIaConstantCache,
        },
    }
    return dense ? "specialized 7th order lazy interpolation" : "1st order linear"
end
